/**phigs.js
version 0.0.4
Authors: Leon Kos, Janez Vrhovec
Revision:
nov 2000; Corrected view mapping LK
Date: 10/25/1999*/

function popen_phigs(err_file, mem_units)
{
	window.status="SIMPLE PHIGS v 0.0.4. Copyright 1998,2000 LECAD,"
		+ " University of Ljubljana"
	phigs_ws = new Array();
}

function pclose_phigs() 
{
	//phigs.print("Phigs closed\n");
}

function popen_ws(ws_id, conn_id, ws_type)
{
	phigs = conn_id;
	
	phigs.open_ws(ws_id);
	phigs_ws[ws_id] = new _phigs_ws();
	with (phigs_ws[ws_id])
	{
		width = phigs.get_width();
		height = phigs.get_height();
		color[0] = new Prgb(0,0,0); // black
		color[1] = new Prgb(1,1,1); // white
		color[2] = new Prgb(1,0,0); // red
		color[3] = new Prgb(0,1,0); // green
		color[4] = new Prgb(0,0,1); // blue
		transform[0][0] = phigs_ws[ws_id].width;
		transform[1][1] = phigs_ws[ws_id].height;
	}
	current_transform = phigs_ws[ws_id].transform;
	current_ws_id = ws_id;
	pset_line_colr_ind(1);
	pset_text_colr_ind(1);
}

function pclose_ws(ws_id)
{
	//phigs.close();
}

function pset_view_ind(view_ind)
{
	//phigs.set_view_id(view_ind);
}

function pupd_ws(ws_id, regen_flag)
{
	//TODO
}

function peval_view_map_matrix(mapping)
{
	var sx = (mapping.win.x_max - mapping.win.x_min)
		/ (mapping.proj_vp.x_max - mapping.proj_vp.x_min);
	var sy = (mapping.win.y_max - mapping.win.y_min)
		/ (mapping.proj_vp.y_max - mapping.proj_vp.y_min);

	var tx = -mapping.proj_vp.x_min * sx + mapping.win.x_min;
	var ty = -mapping.proj_vp.y_min * sy + mapping.win.y_min;
	
	var result_tran = new Pmatrix();


	result_tran[0][0] = sx;	result_tran[0][1] = 0;  result_tran[0][2] = tx;
	result_tran[1][0] = 0;	result_tran[1][1] = sy; result_tran[1][2] = ty;
	result_tran[2][0] = 0;	result_tran[2][1] = 0;  result_tran[2][2] = 1;

	return result_tran;
}



/* SET VIEW REPRESENTATION - sets the requested view orientation matrix,
      the requested view mapping matrix, the requested x-y clipping limits,
      and the requested x-y clipping indicator to the specified values 
*/
function pset_view_rep(ws_id, view_ind, view_rep)
{
	with(phigs_ws[ws_id]) 
	{
		view[view_ind] = view_rep;
		transform = view_rep.map_matrix;
		transform[0][0] *= phigs_ws[ws_id].width;
		transform[1][1] *= phigs_ws[ws_id].height;
		transform[0][2] *= phigs_ws[ws_id].width;
		transform[1][2] *= phigs_ws[ws_id].height;
		
		// TODO orientation
		current_transform = phigs_ws[ws_id].transform;	
	}
}

function pset_ws_win(ws_id, ws_win_limits)
{
	var xscale = 1.0/(ws_win_limits.x_max - ws_win_limits.x_min);
	var yscale = 1.0/(ws_win_limits.y_max - ws_win_limits.y_min);
	var xtrans = -xmin * xscale;
	var ytrans = -ymin * yscale;
	with (phigs_ws[ws_id])
	{
		trfor_w[0][0] = xscale;
		trfor_w[1][1] = yscale;
		trfor_w[2][0] = xtrans;
		trfor_w[2][1] = ytrans;  
	}
}

function pset_ws_vp(ws_id, ws_vp_limits)
{
	//TODO
}

function pset_line_colr_ind(line_colr_ind)
{
	with (phigs_ws[current_ws_id].color[line_colr_ind])
		phigs.line_color(red*255, green*255, blue*255);
}

function pset_text_colr_ind(text_colr_ind)
{
	with (phigs_ws[current_ws_id].color[text_colr_ind])
		phigs.text_color(red*255, green*255, blue*255);
}

function pset_colr_rep(ws_id, colr_ind, colr_rep)
{
	phigs_ws[ws_id].color[colr_ind] = colr_rep; // TODO must be RGB
}


function popen_struct(struct_id)
{
	// nothing
}

function pclose_struct()
{
	// no CSS
}

function ppost_struct(ws_id, struct_id, pri)
{
	// no CSS
}


// polyline
function ppl(n, pxa, pya)
{
	var result = ptran_point(new ppoint(pxa[0], pya[0]), current_transform);
	phigs.polyline(result.x, result.y);
	for (var i = 1; i < point_list.num_points; i++)
	{
		result.x = pxa[i];
		result.y = pya[i];
		result = ptran_point(result, current_transform);
		phigs.polyvertex(result.x,result.y);
	}
}

function ppolyline(point_list)
{
	var result = ptran_point(point_list.points[0], current_transform);
	phigs.polyline(result.x, result.y);
  
	for (var i = 1; i < point_list.num_points; i++)
	{
		result = ptran_point(point_list.points[i], current_transform);
		phigs.polyvertex(result.x,result.y);
	}
}

function pset_linewidth(linewidth)
{
	//nothing
}


function pset_linetype(linetype)
{
	//nothing
}

function ptext(text_pos, char_string)
{
	var result = new Ppoint();
  
	var result = ptran_point(text_pos, current_transform);
	phigs.text(result.x, result.y, 0,  char_string);
}


function  ptran_point(point, tran)
{
	result = new Ppoint();
	result.x = tran[0][0]*point.x + tran[0][1]*point.y + tran[0][2];
	result.y = tran[1][0]*point.x + tran[1][1]*point.y + tran[1][2];
	return result;
}

//PHIGS Objects

// Phigs point
function Ppoint(x, y)
{
	if(Ppoint.arguments.length == 2)
	{
		this.x = x;
		this.y = y;
	}
	else
	{
		this.x = 0.0;
		this.y = 0.0;
	}
}

function Ppoint_list(num_points, points)
{
	if(Ppoint_list.arguments.length == 2)
	{
		this.num_points = num_points;
		this.points = points;
	}
	else
	{
		this.num_points = 0;
		this.points = null;
	}
}

function  Plimit()
{
      this.x_min = 0.0;
      this.x_max = 1.0;
      this.y_min = 0.0;
      this.y_max = 1.0;
}

function  Pview_map()
{
	this.win = new Plimit();
	this.proj_vp = new Plimit();
}

function  Pview_rep()
{
 	this.ori_matrix = new Pmatrix;  /* orientation matrix      */
    this.map_matrix = new Pmatrix;  /* mapping matrix          */
    this.clip_limit = new Plimit;   /* clipping limits         */
    this.xy_clip   = false;         /* X-Y clipping indicator  */
}

function Prgb(red, green, blue)
{
	if (Prgb.arguments.length == 3)
	{
		this.red = red;
		this.green = green;
		this.blue = blue;
	}
	else
	{
		this.red = 0;
		this.green = 0;
		this.blue = 0;
	}
}

function _print_matrix()
{
	alert(this[0][0] + "," + this[0][1] + "," + this[0][2] + "\n"
  		+ this[1][0] + "," + this[1][1] + "," + this[1][2] + "\n"
		+ this[2][0] + "," + this[2][1] + "," + this[2][2] + "\n");
}

// Phigs matrika 
function Pmatrix() 
{
	this.length = 3;
	this[0] = new Array(1, 0, 0);
	this[1] = new Array(0, 1, 0);
	this[2] = new Array(0, 0, 1);
	this.print = _print_matrix;
}

// Phigs workstation
function _phigs_ws()
{
	this.used = false;
	this.width = 0.0;
	this.height = 0.0;
	this.view = new Array(); // views
	this.transform = new Pmatrix();  // current transform world->device
	this.color = new Array;
}

// Constants
// The workstation type can take one of the following enumerated
// values: 
PWODSX = 100; // An OUTPUT, direct mode, single buffer, X workstation 

// regen flags
PFLAG_POSTPONE = 0;
PFLAG_PERFORM = 1;
PFLAG_DEFER = 2;

// clipping index
PIND_NO_CLIP = 0;
PIND_CLIP = 1;

// Local Variables:
// mode: C++
// End:
